<template>
  <div>
    <!-- Table Container Card -->
    <b-card no-body class="mb-0">
      <div class="m-2">
          <b-form >
            <div class="title">
              <h4>Agregar usuario</h4>
            </div>

            <br />
            <div v-for="(alert, idx) in errors" :key="idx">
                <b-alert variant="warning" :show="true" >{{alert[0]}}</b-alert> 
       
              </div>
            <b-row>
              <b-col cols="6">
                <div class="d-flex">
                  <feather-icon icon="UserIcon" size="19" />
                  <h4 class="mb-0 ml-50">Información Personal</h4>
                </div>
              </b-col>

              <b-col cols="6">
                <div class="d-flex">
                  <feather-icon icon="UserIcon" size="19" />
                  <h4 class="mb-0 ml-50">Información de usuario</h4>
                </div>
              </b-col>
            </b-row>
            <br>

            <b-row>
              <b-col cols="6">
                <b-form-group label="Nombres(s)" label-for="name">
                  <b-form-input
                    v-model="user.name"
                    trim
                    :state="validationName"
                    placeholder="Nombre"
                    maxlength="60"
                  />
                  <b-form-invalid-feedback :state="validationName">
                    Este campo es obligatorio
                </b-form-invalid-feedback>
                </b-form-group>

                 <b-form-group label="Apellido(s)" label-for="last_name">
                    <b-form-input
                      id="last_name"
                      v-model="user.last_name"
                      trim
                      :state="validationLastName"
                      placeholder="Apellido(s)"
                      maxlength="60"
                    />
                    <b-form-invalid-feedback :state="validationLastName">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>
        
                <b-form-group label="Teléfono" label-for="phone">
                    <b-form-input
                      id="phone"
                      type="number"
                      v-model="user.phone"
                      trim
                      :state="validationPhone"
                      placeholder="Teléfono(s)"
                      onKeyUp=" if (this.value.length > 10) this.value = this.value.slice(0, 10)"
                    />
                    <b-form-invalid-feedback :state="validationPhone">
                      Ingrese el teléfono correctamente
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Dirección" label-for="address">

                    <b-form-input
                      id="address"
                      v-model="user.address"
                      trim
                      :state="validationAddress"
                      placeholder="Dirección"
                      maxlength="30"
                    />
                    <b-form-invalid-feedback :state="validationAddress">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Puesto" label-for="job">

                    <b-form-input
                      id="job"
                      v-model="user.job"
                      trim
                      :state="validationJob"
                       placeholder="Puesto"
                       maxlength="25"
                    />
                    <b-form-invalid-feedback :state="validationJob">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>
                
               <b-form-group label="Imagen" label-for="image">

                  <b-form-file
                    v-model="user.image"
                    accept="image/*"
                    placeholder="Seleccionar un imagen..."
                    drop-placeholder="Drop file here..."
                    :state="validationImage"
                    @change="previewImage"
                  />
                  <b-form-invalid-feedback :state="validationImage">
                      Este campo es obligatorio
                  </b-form-invalid-feedback>
                </b-form-group>
              </b-col>

              <!-- -------------------------------------- -->

               <b-col cols="6">
                
                <b-form-group label="Nombre de usuario" label-for="nickname">
                    <b-form-input
                      id="nickname"
                      v-model="user.nickname"
                      trim
                      :state="validationUsername"
                      placeholder="Nombre de usuario"
                      maxlength="10"
                    />
                    <b-form-invalid-feedback :state="validationUsername">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Email" label-for="v-email">
                    <b-form-input
                      id="v-email"
                      v-model="user.email"
                      type="email"
                      trim
                      :state="validationEmail"
                      placeholder="Email"
                      maxlength="50"
                    />
                    <b-form-invalid-feedback :state="validationEmail">
                      Ingrese el formato correcto para el emali
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group
                  label="Rol del usuario"
                  label-for="select-user-role"
                  class="w-100"
                >
                  <b-form-select name="select-user-role" v-model="user.role" id="select-user-role">
                    <b-form-select-option v-for="(role,idx) in Roles" :key="idx" :value="role.name">{{role.name}}</b-form-select-option>
                  </b-form-select>
                   
                </b-form-group>
                

                <b-form-group label="Password" label-for="password">
                    <b-form-input
                      id="password"
                      type="password"
                      v-model="user.password"
                      trim
                      :state="validationPassword"
                      placeholder="Password"
                      maxlength="40"
                    />
                    <b-form-invalid-feedback :state="validationPassword">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>
                <br>
                <b-avatar :src="preview" size="150px" rounded />
               </b-col>
            </b-row> 
            <br>
            <b-row>
              <b-col cols="6">
                <b-button
                  v-ripple.400="'rgba(255, 255, 255, 0.15)'"
                  type="submit"
                  variant="primary"
                  class="mr-1"
                  :disabled="lockedSubmit.name || lockedSubmit.last_name ||lockedSubmit.phone || lockedSubmit.address || lockedSubmit.job|| lockedSubmit.image||lockedSubmit.username||lockedSubmit.password || lockedSubmit.email"
                  @click.prevent="saveUser()"
                >
                  Guardar
                </b-button>
                <b-button
                  v-ripple.400="'rgba(186, 191, 199, 0.15)'"
                  type="reset"
                  variant="outline-secondary"
                  :to="{ name: 'apps-users-list' }"
                >
                  Cancelar
                </b-button>
              </b-col>
            </b-row>
          </b-form>
      </div>
    </b-card>
  </div>
</template>

<script>
import BCardCode from "@core/components/b-card-code";
import {
  BCard,
  BRow,
  BCol,
  BFormGroup,
  BFormInput,
  BFormFile,
  BFormCheckbox,
  BForm,
  BButton,
  BAlert,
  BInputGroupPrepend,
  BAvatar,
  BFormSelect,
  BFormSelectOption,
  BFormInvalidFeedback
} from "bootstrap-vue";
import Ripple from "vue-ripple-directive";
import Cleave from "vue-cleave-component";
import { required, email } from '@validations'

export default {
  components: {
    BCard,
    BCardCode,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BFormFile,
    BFormCheckbox,
    BForm,
    BButton,
    BAlert,
    BInputGroupPrepend,
    Cleave,
    BFormInvalidFeedback,
    BAvatar,
    BFormSelect,
    BFormSelectOption,
  },
  directives: {
    Ripple,
  },
  data() {
    return {
      required,
      email,
      user: {
        name: "",
        last_name: "",
        phone: "",
        address: "",
        nickname: "",
        job: "",
        email: "",
        password: "",
        role:'Employee',
        image: null,
      },
      defaultUser: {
        name: "",
        last_name: "",
        phone: "",
        address: "",
        nickname: "",
        job: "",
        email: "",
        password: "",
        role:'Employee',
        image: null,
      },
      options: {
        prefix: {
          blocks: [3, 3, 4]
        },
      },
      preview: null,
      Roles:[],
      hasWritten:{
        name:false,
        last_name:false,
        phone:false,
        address:false,
        job:false,
        username:false,
        email:false,
        password:false,
      },
      lockedSubmit:{
        name:true,
        last_name:true,
        phone:true,
        address:true,
        job:true,
        username:true,
        email:true,
        password:true,
        image:true,
      },
      errors:[]
    };
  },
  methods: {
    previewImage(e) {
      const file = e.target.files[0];
      this.preview = URL.createObjectURL(file);
    },
    saveUser() {
      

      let datos = new FormData();
      datos.append("name", this.user.name);
      datos.append("last_name", this.user.last_name);
      datos.append("phone", this.user.phone);
      datos.append("address", this.user.address);
      datos.append("nickname", this.user.nickname);
      datos.append("job", this.user.job);
      datos.append("email", this.user.email);
      datos.append("role", this.user.role);
      datos.append("password", this.user.password);
      datos.append("image", this.user.image);

      this.$http.post("usuarios", datos).then((res) => {
        if (res.data.message === "agregado") {
          this.$router.push({ name: "apps-users-list" });
          this.user = { ...this.defaultUser };
        }else{
          if(res.data.errors){
            this.errors = res.data.errors
          }
        }
      }).catch((err) => {
        console.log(err);
      });
     
    
  
    },
    getRoles(){
      this.$http.get('roles').then(res=>{
        this.Roles = res.data.roles
      }).catch(err=>{
        console.log(err)
      })
    },
  },
  computed:{
    validationName(){
      if (this.user.name.length > 0){
        this.hasWritten.name = true
      } 
      if(this.hasWritten.name && this.user.name.length > 0 ){
        this.lockedSubmit.name = false
        return true
      }else if(this.hasWritten.name){
        this.lockedSubmit.name = true
        return false
      }
    },
    validationLastName(){
      if (this.user.last_name.length > 0){
        this.hasWritten.last_name = true
      } 
      if(this.hasWritten.last_name && this.user.last_name.length > 0 ){
        this.lockedSubmit.last_name = false
        return true
      }else if(this.hasWritten.last_name){
        this.lockedSubmit.last_name = true
        return false
      }
    },
    validationPhone(){
      if (this.user.phone.length > 0){
        this.hasWritten.phone = true
      }
      if(this.hasWritten.phone){ 
        if (this.user.phone !== '') {
          if(/^[1-9]{10}/.test(this.user.phone)){
            this.lockedSubmit.phone = false
            return true
          }else{
            this.lockedSubmit.phone = true
            return false;
          }
        } else {
            this.lockedSubmit.phone = true
            return false;
        }
      }
    },
    validationAddress(){
      if (this.user.address.length > 0){
        this.hasWritten.address = true
      } 
      if(this.hasWritten.address && this.user.address.length > 0 ){
        this.lockedSubmit.address = false
        return true
      }else if(this.hasWritten.address){
        this.lockedSubmit.address = true
        return false
      }
    },
    validationJob(){
      if (this.user.job.length > 0){
        this.hasWritten.job = true
      } 
      if(this.hasWritten.job && this.user.job.length > 0 ){
        this.lockedSubmit.job = false
        return true
      }else if(this.hasWritten.job){
        this.lockedSubmit.job = true
        return false
      }
    },
    validationImage(){

    if(this.user.image != null){
      this.lockedSubmit.image = false
      return true
    }else{
      this.lockedSubmit.image = true
      return false
    }

  },
  validationUsername(){
    if(this.user.nickname.length > 0){
      this.hasWritten.username = true
    }
    if(this.hasWritten.username){
      if(this.user.nickname.length > 0){
        this.lockedSubmit.username = false
        return true
      }else{
        this.lockedSubmit.username = true
        return false
      }
    }
  },
  validationEmail(){
        if (this.user.email.length > 0){
          this.hasWritten.email = true
        }
        if(this.hasWritten.email){ 
          if (this.user.email !== '') {
            // var patt = new RegExp("/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/");
            if(/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/.test(this.user.email)){
              this.lockedSubmit.email = false
              return true
            }else{
               this.lockedSubmit.email = true
              return false;
            }
          } else {
               this.lockedSubmit.email = true
              return false;
          }
        }
  },
  validationPassword(){

    if(this.user.password > 0){
      this.hasWritten.password = true
    }
    if(this.hasWritten.password){
      if(this.user.password.length > 6){
        this.lockedSubmit.password = false
        return true
      }else{
        this.lockedSubmit.password = true
        return false
      }
    }

  },
  },
  mounted(){
    this.getRoles()
  }
};
</script>




<style >
</style>
